/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by informer-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	time "time"

	controlplanev1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_controlplane/controlplane/v1beta1"
	versioned "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-controlplane/clientset/versioned"
	internalinterfaces "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-controlplane/informers/externalversions/internalinterfaces"
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-controlplane/listers/controlplane/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// KubeadmControlPlaneInformer provides access to a shared informer and lister for
// KubeadmControlPlanes.
type KubeadmControlPlaneInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta1.KubeadmControlPlaneLister
}

type kubeadmControlPlaneInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewKubeadmControlPlaneInformer constructs a new informer for KubeadmControlPlane type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewKubeadmControlPlaneInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredKubeadmControlPlaneInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredKubeadmControlPlaneInformer constructs a new informer for KubeadmControlPlane type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredKubeadmControlPlaneInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ControlplaneV1beta1().KubeadmControlPlanes(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ControlplaneV1beta1().KubeadmControlPlanes(namespace).Watch(context.TODO(), options)
			},
		},
		&controlplanev1beta1.KubeadmControlPlane{},
		resyncPeriod,
		indexers,
	)
}

func (f *kubeadmControlPlaneInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredKubeadmControlPlaneInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *kubeadmControlPlaneInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&controlplanev1beta1.KubeadmControlPlane{}, f.defaultInformer)
}

func (f *kubeadmControlPlaneInformer) Lister() v1beta1.KubeadmControlPlaneLister {
	return v1beta1.NewKubeadmControlPlaneLister(f.Informer().GetIndexer())
}
